/**
 * me.page
 * @copyright   Copyright (C) 2011 MicroEngine Inc.
 */

me.page = {
    tempElementId : null,
    tempElement : null,
    currentHref : null,
    scrollTop : 0,
    editorTabOffset : 38,
    editorPadding : 12,
    xhtml : false,
    rich_editor_button : '',
    init : function()
    {
        if ($('#error_message').length > 0) {
            me.page.openPageSetting();
        } else {
            me.page.closePageSetting();
        }
        me.page.resizeFileName();
        $('#file_name').bind('blur', function(e){
            me.page.resizeFileName();
        });
        if ($('#public_flag_false')[0].checked) {
            $('#public_flag_row').show();
        }
    },
    initEditBox : function(id, thisObj)
    {
        me.page.close();
        me.page.tempElementId = id;
        me.page.tempElement = thisObj;
    },
    open : function(id, thisObj, type, repeatId, repeatNo)
    {
        me.page.initEditBox(id, thisObj);
        $.ajax({
            type: 'POST',
            url: '../Page/open',
            data: ({
                'id' : id,
                'repeat_id' : repeatId,
                'repeat_no' : repeatNo,
                '_form_id' : $('#_form_id').val(),
                '_token' : $('#_token').val()
            }),
            success: function(html){
                $(html).appendTo('body').draggable({
                    'cancel' : ':input, option, .nicEdit-main, .me_editor_main'
                });
                var position = me.page.getPosition(thisObj, $('#me_editor').width(), $('#me_editor').height());
                $('.me_editor').css({
                    top: position.top +'px',
                    left: position.left + 'px',
                    position:'absolute'
                });
                $('#node_value').focus();
                var method_name = type.substr(0,1).toUpperCase() + type.substr(1,type.length);
                try {
                    eval('me.page.open' + method_name + '();');
                } catch (e) {
                }
                me.resize.resizeBox('edit_iframe');
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    openText : function()
    {
    },
    openTextarea : function()
    {
    },
    openSelect : function()
    {
    },
    openSwitch : function()
    {
    },
    openList : function()
    {
    },
    addItem : function(thisObj)
    {
        var $tr = $(thisObj).parents('tr');
        $tr.clone(true).insertAfter($tr).find('input, select').val('');
    },
    removeItem : function(thisObj)
    {
        $(thisObj).parents('tr').remove();
    },
    openRich : function()
    {
        new nicEditor({
            iconsPath : '../../app/assets/img/nicedit/nicEditorIcons.gif',
            maxHeight : 400,
            buttonList : me.page.rich_editor_button,
            xhtml : me.page.xhtml
        }).panelInstance('node_value');
        $('.nicEdit-main').focus();
    },
    openDate : function()
    {
        var defaultValue = ($('#node_value').val() != '') ? $('#node_value').val() : null ;
        var date = Date.parse(defaultValue);
        if (isNaN(date)) {
            defaultValue = null;
        }

        $.datepicker.setDefaults( $.datepicker.regional['ja'] );
        $('#datepicker').datepicker({
            defaultDate: defaultValue,
            dateFormat: 'yy-mm-dd',
            onSelect: function(dateText) {
                $('#node_value').val(dateText);
            }
        });
    },
    openImg : function()
    {
    },
    openSource : function()
    {
    },
    reflect : function()
    {
        var iframeDoc = $('#hidden_iframe')[0].contentWindow.document;
        var html = iframeDoc.body.innerHTML;
        if ($(me.page.tempElement).is('.me_edit_icon')) {
            $(me.page.tempElement).next().remove();
        }
        $(me.page.tempElement).replaceWith(html);
        iframeDoc.open();
        iframeDoc.close();
        me.page.close();
    },
    close : function()
    {
        $('.me_editor').remove();
        $('.ui-datepicker').remove();
    },
    getPosition : function(thisObj, editorWidth, editorHeight)
    {
        var iframeDoc = $('#edit_iframe')[0].contentWindow.document;
        var parentBody = $(window);

        // top position
        var bodyScrollTop = parentBody.scrollTop();
        var iframeScrollTop = $(iframeDoc).scrollTop();
        var iframeOffsetTop = $("#edit_iframe").offset().top;
        var iframeHeight = $("#edit_iframe").height();
        var setTop = $("#edit_iframe").offset().top + $(thisObj).offset().top - me.page.editorTabOffset;

        // left position
        var iframeScrollLeft = $(iframeDoc).scrollLeft();
        var iframeOffsetLeft = $("#edit_iframe").offset().left;
        var iframeWidth = $("#edit_iframe").width();
        var setLeft = iframeOffsetLeft + $(thisObj).offset().left;

        if ($.browser.msie) {
            setLeft -= iframeScrollLeft;
            setTop -= iframeScrollTop;
        } else {
            setTop -= bodyScrollTop;
            if (bodyScrollTop == 0) {
                setTop -= iframeScrollTop;
            }
        }

        // top position
        if (setTop < iframeOffsetTop) {
            setTop = iframeOffsetTop;
        } else if ((setTop + editorHeight) > (iframeOffsetTop + iframeHeight)) {
            setTop -= (setTop + editorHeight) - (iframeOffsetTop + iframeHeight);
            if (setTop < iframeOffsetTop) {
                setTop = iframeOffsetTop;
            }
        }

        // left position
        if (setLeft < iframeOffsetLeft) {
            setLeft = iframeOffsetLeft;
        } else if ((setLeft + editorWidth + me.page.editorPadding) > (iframeOffsetLeft + iframeWidth)) {
            setLeft -= (setLeft + editorWidth + me.page.editorPadding) - (iframeOffsetLeft + iframeWidth);
        }

        return {
            left: setLeft,
            top: setTop
        };
    },
    handlingRepeat : function(command, repeatId, repeatNo)
    {
        me.page.scrollTop = $('#edit_iframe')[0].contentWindow.document.documentElement.scrollTop;
        $.ajax({
            type: 'POST',
            url: '../Page/handling_repeat',
            data: ({
                'command' : command,
                'repeat_id' : repeatId,
                'repeat_no' : repeatNo,
                '_form_id' : $('#_form_id').val(),
                '_token' : $('#_token').val()
            }),
            success: function(html){
                me.page.close();
                $('#edit_iframe')[0].contentWindow.location.reload();
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    reflectList : function()
    {
        me.page.scrollTop = $('#edit_iframe')[0].contentWindow.document.documentElement.scrollTop;
        me.page.close();
        $('#edit_iframe')[0].contentWindow.location.reload();
    },
    openSelectPage : function()
    {
        if ($('.select_page').is(':has(*)')) {
            $('.select_page').empty();
        } else {
            me.page.selectPage('');
        }
    },
    selectPage : function(dir)
    {
        if (dir == null || dir == '') {
            dir = '/';
        }

        $.ajax({
            type: 'POST',
            url: '../Page/select_page',
            data: ({
                'dir' : dir,
                '_form_id' : $('#_form_id').val(),
                '_token' : $('#_token').val()
            }),
            success: function(html){
                $('.select_page').empty().append(html);
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    setLink : function(url)
    {
        $('#url').val(url);
        $('.select_page').empty();
    },
    checkIframe : function()
    {
        $("#edit_iframe").contents().find('a,form').not('.metag > *').bind('click', function(e){
            e.preventDefault();
        });
        if (me.page.scrollTop) {
            $('#edit_iframe')[0].contentWindow.document.documentElement.scrollTop = me.page.scrollTop;
        }
        me.page.currentHref = $('#edit_iframe')[0].contentWindow.location.href;
        setInterval(me.page.checkHref, 100);
    },
    checkHref : function()
    {
        if (me.page.currentHref != $('#edit_iframe')[0].contentWindow.location.href) {
            $('#edit_iframe')[0].contentWindow.history.back();
        }
    },
    resizeFileName : function()
    {
        var size = ($('#file_name').val().length > 0) ? $('#file_name').val().length : 10;
        $('#file_name').css('width', (size * 11) + 'px');
        setTimeout(function (){
            $.ajax({
                type: 'POST',
                url: '../Page/check_file_name',
                data: $('#page_edit_form').serialize(),
                success: function(html){
                    if (html) {
                        $('#file_name_message').empty().addClass('alert alert-error').append(html);
                    } else {
                        $('#file_name_message').empty().removeClass('alert alert-error');
                    }
                    me.resize.resizeBox('edit_iframe');
                },
                error: function(XHR, textStatus, errorThrown){
                    me.error.ajaxError(XHR, textStatus, errorThrown);
                }
            })
        }, 100);
    },
    openPageSetting : function()
    {
        $('.page_setting,#close_page_setting').show();
        $('#open_page_setting').hide();
        me.resize.resizeBox('edit_iframe');
    },
    closePageSetting : function()
    {
        $('.page_setting,#close_page_setting').hide();
        $('#open_page_setting').show();
        me.resize.resizeBox('edit_iframe');
    },
    deletePage : function()
    {
        $.ajax({
            type: 'POST',
            dataType: 'json',
            url: '../Page/post_delete',
            data: ({
                'page_id' : $('#_id').val(),
                '_token' : $('#_token').val()
            }),
            success: function(json){
                if (json.result) {
                    $('#back_link').trigger('click');
                } else {
                    alert(json.message);
                }
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    deleteDraft : function()
    {
        $.ajax({
            type: 'POST',
            dataType: 'json',
            url: '../Page/post_draft_delete',
            data: ({
                'page_id' : $('#_id').val(),
                '_token' : $('#_token').val()
            }),
            success: function(json){
                if (json.result) {
                    $('#back_link').trigger('click');
                } else {
                    alert(json.message);
                }
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    preview : function()
    {
        $.ajax({
            type: 'POST',
            async: false,
            url: '../Page/update_header',
            data: $('#page_edit_form').serialize(),
            success: function(html){
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
        window.open('../Page/preview?_form_id=' + $('#_form_id').val());
    },
    submit : function()
    {
        $('#page_edit_form').trigger('submit');
    },
    save_draft : function()
    {
        $('#save').val('page_draft');
        $('#page_edit_form').trigger('submit');
    }
};