<?php
/**
 * Metag Include
 * @package     Metag
 * @copyright   Copyright (C) 2011 MicroEngine Inc.
 */
class Metag_Include extends Metag
{
    /**
     * タグタイプ
     * @var string
     */
    public $node_type = 'include';
    /**
     * 表示名
     * @var string
     */
    public $display_name = 'インクルード (include)';
    /**
     * ブロック要素かどうか
     * @var boolean
     */
    public $is_block = false;
    /**
     * module name
     * @var string
     */
    public $module_name;
    /**
     * 属性リスト
     * @var array
     */
    public $attr_list = array(
        'id' => 'id',
        'module_name' => 'module_name',
        'ref_page_id' => 'ref_page_id',
    );

    /**
     * 編集view出力
     * @param array $row
     */
    public function edit_view($row)
    {
        // ファイル名のチェック
        if (!preg_match('/^[\w-.]+$/', $this->module_name)) {
            // a-zA-Z-9_-. 以外の文字があれば読み込まない
            return;
        }
        if (file_exists((DATA_ROOT . '/module/' . $this->module_name))) {
            include(DATA_ROOT . '/module/' . $this->module_name);
        }
        return;
    }

    /**
     * 出力
     * @param $row array
     */
    public function output($row)
    {
        // ファイル名のチェック
        if (!preg_match('/^[\w-.]+$/', $this->module_name)) {
            // a-zA-Z-9_-. 以外の文字があれば読み込まない
            return;
        }
        if ($this->output_method === Template_Logic::OUTPUT_DYNAMIC) {
            return '<?php $helper->include_module(\'' . $this->module_name . '\') ;?>';
        } else {
            if (file_exists((DATA_ROOT . '/module/' . $this->module_name))) {
                return Me_Util::get_file(DATA_ROOT . '/module/' . $this->module_name);
            }
        }
    }

    /**
     * タグ編集
     */
    public function set_post_data()
    {
        $mapping = $this->attr_list;
        Me_Util::post_data_to_object($this, $mapping);
    }
}